{% extends 'dashboard/dashboard_content.html' %}

{% block head_block %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/css/bootstrap-select.min.css">

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/js/bootstrap-select.min.js"></script>

{% endblock %}

{% block title %}
    Bulk OD
{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-plus"></i>
                Grant Bulk On duty
            </h2>
            <div class="clearfix"></div>
        </div>
        <div class="container" align="center">
            <div role="alert" class="alert alert-warning alert-dismissible fade in" align="center">
                <button aria-label="Close" data-dismiss="alert" class="close" type="button"><span
                        aria-hidden="true">×</span>
                </button>
                {% if od_request %}
                    <p><em> You can alter the OD details </em></p>
                {% else %}
                    <p><em><h5> Start and End date are same if it is only ONE DAY OD </h5></em></p>
                {% endif %}
            </div>
        </div>
        <div class="x_content">
            <div class="row">
                <div class="col-md-12 col-sm-12 col-xs-12">
                    <form id="demo-form2" class="form-horizontal form-label-left">
                        <div class="form-horizontal form-label-left">
                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Department
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select class="form-control" name="dept" id="dept" data-width="auto"
                                            required>
                                        <option disabled selected>-----------</option>
                                        {% for department in department_list %}
                                            <option value="{{ department.id }}"
                                                    data-subtext="{{ department.acronym }}">{{ department }}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Batches
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <select name="batch" id="batch" class="form-control"
                                            required>
                                        <option disabled selected>-----------</option>
                                    </select>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Reason
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                <textarea id="reason" class="form-control" type="text" name="roll_no"
                                          maxlength="1500" placeholder="Reason for OD"
                                          required></textarea>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Start Date
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="datepicker" class="form-control" type="text"
                                           required readonly>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    End Date
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <input id="enddatepicker" class="form-control" type="text"
                                           required readonly>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12">
                                    <button id="add" type="submit" class="btn1 btn-dark-green">Issue OD</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <form id="dummy_form" method="POST">
        {% csrf_token %}
    </form>

    <script type="text/javascript">

        $(function () {
            $("#datepicker").datepicker({dateFormat: 'dd/mm/yy'});
        });

        $(function () {
            $("#enddatepicker").datepicker({dateFormat: 'dd/mm/yy'});
        });


        {% if bulk_color == 'success' %}
            $(function () {
                new PNotify({
                    title: 'Success!',
                    text: '{{ bulk_message_report }}',
                    type: 'success',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}

        {% if bulk_color == 'danger' %}
            $(function () {
                new PNotify({
                    title: 'Success!',
                    text: '{{ bulk_message_report }}',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}

        {% if error == 'holiday' %}
            $(function () {
                new PNotify({
                    title: 'Warning!',
                    text: 'Start or End date cannot be a holiday',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}

        {% if error == 'success' %}
            $(function () {
                new PNotify({
                    title: 'Success!',
                    text: '{{ success_message }}',
                    type: 'success',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}
        {% if error == 'duplicate' %}
            $(function () {
                new PNotify({
                    title: 'Oh Snap!',
                    text: '{{ crash_message }}',
                    type: 'error',
                    styling: 'bootstrap3',
                    min_height: "20px",
                    mobile: {'styling': true}
                });
            });
        {% endif %}


        $(document).on("change", '#dept', function (e) {
            var dept = $(this).val();
            //alert(dept);

            $.ajax({
                type: "POST",
                data: {
                    department: dept,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'bulkod' %}',
                success: function (data) {
                    $('#batch').empty();
                    $('#batch').append('<option disabled selected>' + '-----------' + '</option>');
                    $.each(data.list, function (key, val) {
                        $('#batch').append('<option value="' + val.semester_instance_pk + '">' + val.display_text + '</option>');
                    })

                }
            });
        });

        //For getting CSRF token
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $(document).on("submit", '#demo-form2', function (e) {
            e.preventDefault();

            if ($('#dept').val() == null) {
                alert('Select Department!');
                return;
            }

            if ($('#batch').val() == null) {
                alert('Select Batch!');
                return;
            }

            var start_date = $('#datepicker').datepicker('getDate');
            var end_date = $('#enddatepicker').datepicker('getDate');

            if (start_date > end_date) {
                alert('Start date cannot exceed end date');
                $('#datepicker').val("");
                $('#datepicker1').val("");
                $('#datepicker').focus();
                return;
            }

            var $hiddenInput = $('<input/>', {
                type: 'hidden',
                value: getCookie('csrftoken'),
                name: 'csrfmiddlewaretoken'
            });
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#dept').val(), name: 'department_id'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#batch').val(), name: 'batch'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#reason').val(), name: 'reason'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#datepicker').val(), name: 'date'});
            $hiddenInput.appendTo('form');

            var $hiddenInput = $('<input/>', {type: 'hidden', value: $('#enddatepicker').val(), name: 'enddate'});
            $hiddenInput.appendTo('form');

            $('#dummy_form').submit();
        });
    </script>

{% endblock %}